var FS=require ("SFileNW");
var js=FS.get(module.filename).rel("../../js/");
console.log("js.path",js.path());
exports.genShim=function () {
    var reqConf=require ("../js/reqConf").conf;
    var revPath={};
    var shim={};
    for (var i in reqConf.shim) shim[i]=reqConf.shim[i];
    var com=/^((\/\*([^\/]|[^*]\/|\r|\n)*\*\/)*(\/\/.*\r?\n)*)*/g;
    for (var name in reqConf.paths) {
        //console.log(name);
        var fn=reqConf.paths[name]+".js";
        revPath[fn]=name;
        //console.log(fn);
        var f=js.rel(fn);
        if (!f.exists()) {
            console.log(f+" not exists");
            continue;
        }
        var src=f.text();
        src=src.replace(com,"");
        var isModule=src.match(/(\brequirejs\b)|(\brequire\b)|(\bdefine\b)/);
        if (name in shim) {
            if (isModule) {
                console.log(f+"("+name+") has both shim and require/define");
            }
            continue;
        }
        if (isModule) {
            if (src.match(/\[([^\]]*)\]/)) {
                var reqs=RegExp.lastMatch;

                try {
                    var reqa=eval(reqs);
                    shim[name]={deps:reqa, exports:name ,srcHead: src.substring(0,50) };
                } catch(e) {
                    console.log("dumpScript:Error eval "+name+" src:\n"+reqs);
                    throw e;
                }
            } else {
                console.log(name+" does not have dependencty section / "+f);
            }
        }
    }
    var excludes=/(ace-noconflict)|(^server)/;
    js.recursive(function (s) {
        if (s.relPath(js).match(excludes)) return;
        if (s.endsWith(".js")) {
            var r=s.relPath(js);
            if (!revPath[r] ) console.log(r+" is not scanned");
        }
    });
    var nrq={shim:shim,paths:reqConf.paths};
    return nrq;
};
var excludes={timbre:1, ace:1};
exports.concat=function (params) {
    var names=params.names;
    var outFile=params.outFile;
    var reqConf=params.reqConf;
    var progs=[];
    var visited={};
    for (var i in excludes) visited[i]=true;
    names.forEach(loop);
    function loop(name) {
        if (visited[name]) return;
        var s=reqConf.shim[name];
        visited[name]=true;
        if (s && s.deps) {
            s.deps.forEach(loop);
        }
        progs.push(name);
    }
    var buf="";
    buf+="// Created at "+new Date()+"\n";
    var reqSim=js.rel("lib/requireSimulator.js").text().replace(/\r/g,"");
    buf+=reqSim+"\n";
    progs.forEach(function (name) {
        buf+="requireSimulator.setName('"+name+"');\n";
        var fn=reqConf.paths[name];
        if (!fn) console.log("dumpScript.js: file not found for module "+name);
        buf+=js.rel(fn+".js").text().replace(/\r/g,"")+"\n";
    });
    buf+="requireSimulator.setName();\n";
    console.log("Done generate ",names);
    var ouf=js.rel("gen/"+outFile+"_concat.js");
    ouf.text(buf);

    var ugf=js.rel("gen/"+outFile+"_concat.min.js");
    uglify(ouf, ugf);
};
function uglify(srcF, dstF) {
    try {
        var UglifyJS = require("uglify-js");
        var r=UglifyJS.minify(srcF.path());
        dstF.text(r.code);

    }catch(e) {
        console.log("Uglify fail "+e);
        dstF.text(srcF.text());
    }
}